/* 
 * File:   main.c
 * Author: yoshihiro
 *
 * Created on 2010/06/28, 10:01
 */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include<SDL/SDL.h>
#include<SDL/SDL_image.h>
#include<SDL/SDL_draw.h>
#include<SDL/SDL_rotozoom.h>

#define ESC_KEY 27

#define VIDEO_W 480
#define VIDEO_H 480
#define VIDEO_BIT 24
#define FPS 30
#define INTERVAL 1000/FPS

#define RAD(k) ((k)*3.14159265358979/180.0)

//ゲームシーン管理用定数
#define TITLE 1
#define PLAY 2
#define RANKING 3
#define HELP 4
#define PAUSE 5
#define SELECT 6
#define HELP_2 7
#define HELP_3 8
#define YES_NO 9
#define OK 10

short GameScene = TITLE;
short Ang;
short SCFlg = 1;
short CCFlg = 1;
short ExitFlg = 0;
short kosuu; //シーソー数
short _select;
double _sin, _cos, _sin2;
int Ranking[15];
int red;

typedef struct BALL {
    float x; //ボールの中心座標X
    float y; //             Y
    float vx; //ボールのX方向への加速度
    float vy; //ボールのY方向への加速度
    short Width; //ボールの幅
    short Height; //ボールの高さ
    short SFlg; //シーソーとの接地フラグ
    short color; //ボールの色
    SDL_Rect src;
    SDL_Rect dsr;
} BALL;

typedef struct SEESAW {
    float x;
    float y;
    int Width;
    int Height;
    float left_x;
    float left_y;
    float right_x;
    float right_y;
    float kata;
    short MFlg;
    SDL_Rect src;
    SDL_Rect dsr;
} SEESAW;

typedef struct KEYFLGS {
    short Up;
    short Down;
    short Left;
    short Right;
    short Select;
    short Return;
    short Z;
} KEYFLGS;

BALL ball;
SEESAW s[10];
KEYFLGS KeyFlg;

short EFlg = 0;
short MFlg = 0;

int scr = 0;

SDL_Rect Scrsrc;
SDL_Rect Scrdsr;

SDL_Surface *screen;
SDL_Surface *v_vram;
SDL_Surface *RankImage;
SDL_Event event;
int rgb;
SDL_PixelFormat *fmt;

int SeesawHit(BALL b, SEESAW s[], int kosuu);
void RankingJudge(short EFlg, short MFlg, int scr);
void RankingInit(void);
void RankingDelete(void);
void BallInit(void);
void LoadMap(void);
void fps_wait(void);
void fps_no(void);

int main(int argc, char *argv[]) {
    unsigned char flg = 0;
    SDL_Surface *Simage;
    SDL_Surface *Bimage;
    SDL_Surface *Simage2;
    SDL_Surface *SWimage;
    SDL_Surface *SWimage2;
    SDL_Surface *TitleImage;
    SDL_Surface *ModeImage;
    SDL_Surface *HelpImage;
    SDL_Surface *HelpImage2;
    SDL_Surface *HelpImage3_2;
    SDL_Surface *YesNoImage;
    SDL_Surface *OkImage;

    //画面全体用
    SDL_Rect src1 = {0, 0, 480, 480};
    SDL_Rect dsr1 = {0, 0, 480, 480};

    //選択四角用
    SDL_Rect dsr2;
    dsr2.x = 0;
    dsr2.y = 0;

    float b_w;

    short SFlg = 0;
    short w = 9;
    short mcnt = 0;
    short mp = 0;
    short time = 60;

    int scnt = 0;
    int scr_w;
    int sx;
    int tmp;
    int Mode=0;
    int RFlg;
    int x;

    int k;

    int i, j, l;

    long GameTime;

    if (SDL_Init(SDL_INIT_VIDEO) < 0) {
        return -1;
    }
    SDL_WM_SetIcon(SDL_LoadBMP("png/Icon.bmp"),NULL);
    SDL_WM_SetCaption("JumpBall", NULL);
    screen = SDL_SetVideoMode(VIDEO_W, VIDEO_H, VIDEO_BIT, SDL_SWSURFACE);
    v_vram = SDL_SetVideoMode(VIDEO_W, VIDEO_H, VIDEO_BIT, SDL_SWSURFACE);
    if (screen == NULL) {
        return -1;
    }

    BallInit();

    //画像読込
    Bimage = (SDL_Surface *) IMG_Load("png/bimage.png");
    if (Bimage == NULL)printf("NOT READ FILE\n");

    Simage = (SDL_Surface *) IMG_Load("png/simage.png");
    if (Simage == NULL)printf("NOT READ FILE\n");

    Simage2 = (SDL_Surface *) IMG_Load("png/simage2.png");
    if (Simage2 == NULL)printf("NOT READ FILE\n");

    SWimage = (SDL_Surface *) IMG_Load("png/simage.png");
    if (SWimage == NULL)printf("NOT READ FILE\n");

    SWimage2 = (SDL_Surface *) IMG_Load("png/simage2.png");
    if (SWimage2 == NULL)printf("NOT READ FILE\n");

    TitleImage = (SDL_Surface *) IMG_Load("png/title.png");
    if (TitleImage == NULL)printf("NOT READ FILE\n");

    RankImage = (SDL_Surface *) IMG_Load("png/ranking.png");
    if (RankImage == NULL)printf("NOT READ FILE\n");

    ModeImage = (SDL_Surface *) IMG_Load("png/select.png");
    if (ModeImage == NULL)printf("NOT READ FILE\n");

    HelpImage = (SDL_Surface *) IMG_Load("png/help.png");
    if (HelpImage == NULL)printf("NOT READ FILE\n");

    HelpImage2 = (SDL_Surface *) IMG_Load("png/help_2.png");
    if (HelpImage2 == NULL)printf("NOT READ FILE\n");

    HelpImage3_2 = (SDL_Surface *) IMG_Load("png/help_3_2.png");
    if (HelpImage3_2 == NULL)printf("NOT READ FILE\n");

    YesNoImage = (SDL_Surface *) IMG_Load("png/yes_no.png");
    if (YesNoImage == NULL)printf("NOT READ FILE\n");

    OkImage = (SDL_Surface *) IMG_Load("png/ok.png");
    if (OkImage == NULL)printf("NOT READ FILE\n");

    srand(SDL_GetTicks());

    KeyFlg.Z=1;

    while (flg == 0) {
        while (SDL_PollEvent(&event)) {
            switch (event.type) {
                case SDL_KEYDOWN:
                    switch (event.key.keysym.sym) {
                        case ESC_KEY:
                            flg = 1;
                            break;
                        case SDLK_UP:
                            KeyFlg.Up = 1;
                            break;
                        case SDLK_DOWN:
                            KeyFlg.Down = 1;
                            break;
                        case SDLK_LEFT:
                            KeyFlg.Left = 1;
                            break;
                        case SDLK_RIGHT:
                            KeyFlg.Right = 1;
                            break;
                        case SDLK_RETURN:
                            KeyFlg.Select = 1;
                            break;
                        case SDLK_BACKSPACE:
                            KeyFlg.Return = 1;
                            break;
                        case SDLK_z:
                            KeyFlg.Z = 1;
                            break;
                    }
                    break;

                case SDL_KEYUP:

                    switch (event.key.keysym.sym) {
                        case SDLK_UP:
                            KeyFlg.Up = 0;
                            break;
                        case SDLK_DOWN:
                            KeyFlg.Down = 0;
                            break;
                        case SDLK_LEFT:
                            KeyFlg.Left = 0;
                            break;
                        case SDLK_RIGHT:
                            KeyFlg.Right = 0;
                            break;
                        case SDLK_BACKSPACE:
                            KeyFlg.Return = 0;
                            break;
                        case SDLK_z:
                            KeyFlg.Z = 0;
                            break;
                    }
                    break;

                case SDL_QUIT:
                    flg = 1;
                    break;
            }
        }
        fmt = screen->format;
        rgb = SDL_MapRGB(fmt, 0xff, 0xff, 0xff);
        SDL_FillRect(screen, NULL, rgb);
        red = SDL_MapRGB(fmt, 0xff, 0x00, 0x00);
        SDL_FillRect(v_vram, NULL, rgb);

        switch (GameScene) {
            case TITLE:
                if (KeyFlg.Up == 1) {
                    KeyFlg.Up = 2;
                    _select--;
                    if (_select < 0) {
                        _select = 3;
                    }
                }
                if (KeyFlg.Down == 1) {
                    KeyFlg.Down = 2;
                    _select++;
                    if (_select > 3) {
                        _select = 0;
                    }
                }
                if (KeyFlg.Select == 1) {
                    KeyFlg.Select = 2;
                    if (_select == 0) {
                        GameScene = SELECT;
                        _select = 0;
                    } else if (_select == 1) {
                        RankingInit();
                        GameScene = RANKING;
                        scr=0;
                        _select = 0;
                    } else if (_select == 2) {
                        GameScene = HELP;
                        _select = 0;
                    } else {
                        flg = 1;
                    }
                }
                ball.dsr.x = 140;
                ball.dsr.y = 225 + ball.Height / 2 + _select * 50;
                SDL_BlitSurface(Bimage, &ball.src, screen, &ball.dsr);
                SDL_BlitSurface(TitleImage, &src1, screen, &dsr1);
                Draw_Rect(v_vram, 158, 225 + _select * 50, 164, 33, red);
                break;

            case SELECT:

                if (KeyFlg.Up == 1) {
                    KeyFlg.Up = 2;
                    _select--;
                    if (_select < 0) {
                        _select = 2;
                    }
                }
                if (KeyFlg.Down == 1) {
                    KeyFlg.Down = 2;
                    _select++;
                    if (_select > 2) {
                        _select = 0;
                    }
                }
                if (KeyFlg.Return == 1) {
                    KeyFlg.Return = 2;
                    GameScene = TITLE;
                    _select = 0;
                }
                if (KeyFlg.Select == 1) {
                    KeyFlg.Select = 2;
                    LoadMap();
                    if (_select == 0) {
                        EFlg = 1;
                        MFlg = 0;
                    } else if (_select == 1) {
                        MFlg = 1;
                        EFlg = 1;
                        for (i = 0; i < 10; i++) {
                            s[i].MFlg = 1;
                        }
                    } else {
                        MFlg = 0;
                        EFlg = 0;
                    }
                    BallInit();
                    scr = 0;
                    w = 9;
                    _select = 0;
                    Ang = 0;
                    scnt = 0;
                    SFlg = 0;
                    mcnt = 0;
                    mp = 0;
                    //タイム関連初期化
                    time = 60;
                    GameTime = SDL_GetTicks();
                    RankingInit();
                    GameScene = PLAY;
                }
                ball.dsr.x = 140;
                ball.dsr.y = 255 + ball.Height / 2 + _select * 50;
                SDL_BlitSurface(Bimage, &ball.src, screen, &ball.dsr);
                SDL_BlitSurface(ModeImage, &src1, screen, &dsr1);
                Draw_Rect(v_vram, 158, 255 + _select * 50, 164, 33, red);
                break;

            case PLAY:

                if (KeyFlg.Left == 1) {
                    Ang -= 2;
                    if (Ang <= -25) {
                        Ang = -25;
                    }
                }
                if (KeyFlg.Right == 1) {
                    Ang += 2;
                    if (Ang >= 25) {
                        Ang = 25;
                    }
                }
                if (KeyFlg.Z == 1) {
                    KeyFlg.Z = 2;
                    if (ball.SFlg && Ang != 0) {
                        ball.SFlg = 0;
                        ball.vy = (float) - 8;
                        if (!s[i].MFlg) {
                            if (Ang > 0) {
                                ball.y = (float) (s[k].y - _sin * s[k].Width / 2 - 8);
                            } else if (Ang < 0) {
                                ball.y = (float) (s[k].y + _sin * s[k].Width / 2 - 8);
                            }
                        } else {
                            if (Ang < 0) {
                                ball.y = (float) (s[k].y - _sin2 * s[k].Width / 2 - 8);
                            } else if (Ang > 0) {
                                ball.y = (float) (s[k].y + _sin2 * s[k].Width / 2 - 8);
                            }
                        }
                    }
                    Ang = 0;
                }

                _sin = sin(RAD(Ang));
                _cos = cos(RAD(Ang));
                _sin2 = -_sin;

                //シーソー座標更新
                SWimage = rotozoomSurface(Simage, -Ang, 1.0, SMOOTHING_ON);
                SWimage2 = rotozoomSurface(Simage2, Ang, 1.0, SMOOTHING_ON);
                for (i = 0; i < kosuu; i++) {
                    if (s[i].x>-128 && s[i].x < 480 + 128) {
                        if (!s[i].MFlg) {
                            if (Ang % 180 <= 90) {
                                s[i].left_x = (float) (s[i].x - _cos * s[i].Width / 2 + 1);
                                s[i].left_y = (float) (s[i].y - _sin * s[i].Width / 2 - 8);
                                s[i].right_x = (float) (s[i].x + _cos * s[i].Width / 2 + 5);
                                s[i].right_y = (float) (s[i].y + _sin * s[i].Width / 2 - 8);
                            } else {
                                s[i].left_x = (float) (s[i].x + _cos * s[i].Width / 2 + 5);
                                s[i].left_y = (float) (s[i].y + _sin * s[i].Width / 2 - 8);
                                s[i].right_x = (float) (s[i].x - _cos * s[i].Width / 2 + 1);
                                s[i].right_y = (float) (s[i].y - _sin * s[i].Width / 2 - 8);
                            }
                            s[i].dsr.x = s[i].x - SWimage->w / 2;
                            s[i].dsr.y = s[i].y - SWimage->h / 2;
                            s[i].dsr.w = SWimage->w;
                            s[i].dsr.h = SWimage->h;
                            SDL_BlitSurface(SWimage, NULL, screen, &s[i].dsr);

                        } else {
                            if (Ang % 180 <= 90) {
                                s[i].left_x = (float) (s[i].x - _cos * s[i].Width / 2 + 1);
                                s[i].left_y = (float) (s[i].y - _sin2 * s[i].Width / 2 - 8);
                                s[i].right_x = (float) (s[i].x + _cos * s[i].Width / 2 + 5);
                                s[i].right_y = (float) (s[i].y + _sin2 * s[i].Width / 2 - 8);
                            } else {
                                s[i].left_x = (float) (s[i].x + _cos * s[i].Width / 2 + 5);
                                s[i].left_y = (float) (s[i].y + _sin2 * s[i].Width / 2 - 8);
                                s[i].right_x = (float) (s[i].x - _cos * s[i].Width / 2 + 1);
                                s[i].right_y = (float) (s[i].y - _sin2 * s[i].Width / 2 - 8);
                            }
                            s[i].dsr.x = s[i].x - SWimage2->w / 2;
                            s[i].dsr.y = s[i].y - SWimage2->h / 2;
                            s[i].dsr.w = SWimage2->w;
                            s[i].dsr.h = SWimage2->h;
                            SDL_BlitSurface(SWimage2, NULL, screen, &s[i].dsr);
                        }
                        s[i].kata = ((s[i].left_y - s[i].right_y) / 128.0);

                    }
                }

                //ボールX座標更新
                ball.x += ball.vx;
                if (ball.x > VIDEO_W / 2) {
                    ball.x = VIDEO_W / 2;

                    //スコア更新
                    if (scr + (ball.vx * 0.75) > 99999) {
                        scr = 99999;
                    } else {
                        scr += ball.vx * 0.75;
                        scnt += ball.vx * 0.75;
                        mcnt += ball.vx * 0.75;
                        if (!SFlg && (scnt >= 1000)) {
                            SFlg = 1;
                            scr_w = scr / 1000;
                            sx = 480;
                            scnt = 0;
                        }
                        //ミラー確率更新
                        if (mcnt >= 3000) {
                            mcnt = 0;
                            mp += 5;
                            if (mp > 80) {
                                mp = 80;
                            }
                        }
                    }

                    //スクロール（進行）
                    for (i = 0; i < kosuu; i++) {
                        s[i].x -= ball.vx;
                        //新しいシーソー座標の設定
                        if (s[i].x<-150) {
                            s[i].x = rand() % (151 - 28) + 128 + s[w].x;
                            if (s[w].y < 150) {
                                s[i].y = rand() % 301 + 50;
                            } else {
                                if (s[w].y < 400) {
                                    s[i].y = rand() % 201 - 100 + s[w].y;
                                    if (s[i].y + s[i].Height > 480) {
                                        s[i].y = 480 - s[i].Height;
                                    }
                                } else {
                                    s[i].y = rand() % 21 - 110 + s[w].y;
                                }
                                //新しいシーソーがミラーかどうか
                                if (!MFlg) {
                                    if ((rand() % 100 + 1) <= mp) {
                                        s[i].MFlg = 1;
                                    } else {
                                        s[i].MFlg = 0;
                                    }
                                }
                            }
                            w++;
                            if (w > 9) {
                                w = 0;
                            }
                        }
                    }
                    //スコアテロップ表示(100m(scr=1000)毎に)
                    if (SFlg) {
                        if (scr_w >= 10) {
                            i = 10000;
                            Scrsrc.x = 0;
                            Scrsrc.y = 125;
                            Scrsrc.w = 50;
                            Scrsrc.h = 50;
                            Scrdsr.x = sx + 160;
                            Scrdsr.y = 200;
                            SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                        } else {
                            i = 1000;
                            Scrsrc.x = 0;
                            Scrsrc.y = 125;
                            Scrsrc.w = 50;
                            Scrsrc.h = 50;
                            Scrdsr.x = sx + 120;
                            Scrdsr.y = 200;
                            SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                        }
                        tmp = scr_w * 1000;
                        for (j = 0; i >= 10; i /= 10, j++) {
                            Scrsrc.x = (tmp / i)*50;
                            Scrsrc.y = 75;
                            Scrsrc.w = 50;
                            Scrsrc.h = 50;
                            Scrdsr.x = sx + j * 40;
                            Scrdsr.y = 200;
                            SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                            tmp %= i;
                        }
                        sx -= 15;
                        if (sx<-300) {
                            SFlg = 0;
                        }
                    }
                }

                //ボールY座標更新
                b_w = ball.vy;
                if (b_w < 0) {
                    b_w = -b_w;
                }
                for (i = 0; i < (int) (b_w / 0.1); i++) {
                    if (ball.vy < 0) {
                        ball.y -= 0.1;
                    } else {
                        ball.y += 0.1;
                    }
                    k = SeesawHit(ball, s, kosuu);
                    if (k != -1) {
                        ball.SFlg = 1;
                        ball.vy = 0;
                        break;
                    } else {
                        ball.SFlg = 0;
                    }
                }

                k = SeesawHit(ball, s, kosuu);
                if (k != -1) {
                    ball.SFlg = 1;
                    ball.vy = 0;
                } else {
                    ball.SFlg = 0;
                }

                //ボールのX方向の加速度、シーソー上ならY座標、シーソー上でないのならY方向の加速度の更新
                if (ball.SFlg) {
                    if (!s[k].MFlg) {
                        ball.vx += (float) 0.125 * _sin * 1.5;
                    } else {
                        ball.vx += (float) 0.125 * _sin2 * 1.5;
                    }
                    if (ball.x < s[k].left_x) {
                        ball.y = s[k].left_y - ball.Height / 2;
                    } else {
                        ball.y = s[k].left_y - ((ball.x - s[k].left_x) * s[k].kata) - ball.Height / 2;
                    }
                } else {
                    ball.vy += 0.4;
                }
                ball.dsr.x = ball.x - ball.Width / 2;
                ball.dsr.y = ball.y - ball.Height / 2;
                SDL_BlitSurface(Bimage, &ball.src, screen, &ball.dsr);

                //ボールが画面外に出たらランキング更新処理をしランキングへ
                if ((ball.y + (ball.Height / 2)) > 500) {
                    RankingJudge(EFlg, MFlg, scr); //ランクイン判定
                    //ランキングデータ再初期化
                    RankingInit();
                    GameScene = RANKING;
                    KeyFlg.Z=1;
                    //ランキングモードの設定
                    if (MFlg) { //ミラー
                        Mode = 2;
                    } else if (EFlg) { //エンドレス
                        Mode = 3;
                    } else { //ワンミニッツ
                        Mode = 1;
                    }
                    break;
                }

                //エンドレスモードじゃない場合タイム減少
                if (!EFlg) {
                    if (SDL_GetTicks() - GameTime > 1000) {
                        GameTime = SDL_GetTicks();
                        time--;
                        //タイムオーバーならランキング更新処理へ
                        if (time <= 0) {
                            RankingJudge(EFlg, MFlg, scr); //ランクイン判定
                            //ランキングデータ再初期化
                            RankingInit();
                            GameScene = RANKING;
                            KeyFlg.Z=1;
                            //ランキングモードをワンミニッツにしソフトラベルを更新
                            Mode = 1;
                            break;
                        }
                    }
                    //残りタイムを表示
                    Scrsrc.x = -10;
                    Scrsrc.y = 275;
                    Scrsrc.w = 110;
                    Scrsrc.h = 50;
                    Scrdsr.x = 190;
                    Scrdsr.y = 0;
                    SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                    tmp = time;
                    for (i = 10, j = 0; i >= 1; i /= 10, j++) {
                        Scrsrc.x = (tmp / i)*25;
                        Scrsrc.y = 250;
                        Scrsrc.w = 25;
                        Scrsrc.h = 25;
                        Scrdsr.x = 215 + j * 25;
                        Scrdsr.y = 45;
                        SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                        tmp %= i;
                    }
                }

                //現在のスコアを表示
                tmp = scr;
                for (i = 10000, j = 0; i >= 1; i /= 10, j++) {
                    Scrsrc.x = (tmp / i)*25;
                    Scrsrc.y = 250;
                    Scrsrc.w = 25;
                    Scrsrc.h = 25;
                    Scrdsr.x = 40 + j * 20;
                    Scrdsr.y = 30;
                    SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                    tmp %= i;
                }
                Scrsrc.x = 275;
                Scrsrc.y = 250;
                Scrsrc.w = 25;
                Scrsrc.h = 25;
                Scrdsr.x = 112;
                Scrdsr.y = 30;
                SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                Scrsrc.x = 250;
                Scrsrc.y = 250;
                Scrsrc.w = 25;
                Scrsrc.h = 25;
                Scrdsr.x = 140;
                Scrdsr.y = 30;
                SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);

                //トップスコアを表示
                Scrsrc.x = 0;
                Scrsrc.y = 325;
                Scrsrc.w = 50;
                Scrsrc.h = 30;
                Scrdsr.x = 290;
                Scrdsr.y = 28;
                SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                if (MFlg) { //ミラー
                    tmp = Ranking[10];
                    for (i = 10000, j = 0; i >= 1; i /= 10, j++) {
                        Scrsrc.x = (tmp / i)*25;
                        Scrsrc.y = 250;
                        Scrsrc.w = 25;
                        Scrsrc.h = 25;
                        Scrdsr.x = 340 + j * 20;
                        Scrdsr.y = 30;
                        SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                        tmp %= i;
                    }
                } else if (EFlg) { //エンドレス
                    tmp = Ranking[0];
                    for (i = 10000, j = 0; i >= 1; i /= 10, j++) {
                        Scrsrc.x = (tmp / i)*25;
                        Scrsrc.y = 250;
                        Scrsrc.w = 25;
                        Scrsrc.h = 25;
                        Scrdsr.x = 340 + j * 20;
                        Scrdsr.y = 30;
                        SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                        tmp %= i;
                    }
                } else { //ワンミニッツ
                    tmp = Ranking[5];
                    for (i = 10000, j = 0; i >= 1; i /= 10, j++) {
                        Scrsrc.x = (tmp / i)*25;
                        Scrsrc.y = 250;
                        Scrsrc.w = 25;
                        Scrsrc.h = 25;
                        Scrdsr.x = 340 + j * 20;
                        Scrdsr.y = 30;
                        SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                        tmp %= i;
                    }
                }
                Scrsrc.x = 275;
                Scrsrc.y = 250;
                Scrsrc.w = 25;
                Scrsrc.h = 25;
                Scrdsr.x = 412;
                Scrdsr.y = 30;
                SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                Scrsrc.x = 250;
                Scrsrc.y = 250;
                Scrsrc.w = 25;
                Scrsrc.h = 25;
                Scrdsr.x = 440;
                Scrdsr.y = 30;
                SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);

                break;

            case RANKING:
                //エンターキーが押されたらタイトルへ
                if (KeyFlg.Select == 1) {
                    if (!RFlg) {
                        KeyFlg.Select = 2;
                        GameScene = TITLE;
                    }
                }
                //バックスペースが押されたらランキング初期化
                if (KeyFlg.Return == 1) {
                    if (!RFlg) {
                        KeyFlg.Return = 2;
                        GameScene = YES_NO;
                        _select = 0;
                    }
                }
                //Zキーが押されたら表示モード切り替え
                if (KeyFlg.Z == 1) {
                    KeyFlg.Z = 2;
                    if (!RFlg) {
                        RFlg = 1;
                        x = 0;
                    } else {
                        RFlg = 0;
                        Mode++;
                        if (!SCFlg) {
                            if (Mode > 2) {
                                Mode = 1;
                            }
                        } else {
                            if (Mode > 3) {
                                Mode = 1;
                            }
                        }
                    }
                }

                if (RFlg) {
                    x += 16;
                    if (x + 16 >= 480) {
                        RFlg = 0;
                        Mode++;
                        if (!SCFlg) {
                            if (Mode > 2) {
                                Mode = 1;
                            }
                        } else {
                            if (Mode > 3) {
                                Mode = 1;
                            }
                        }
                    }
                    if (RFlg) {
                        Scrsrc.x = 0;
                        Scrsrc.y = 175;
                        Scrsrc.w = 350;
                        Scrsrc.h = 75;
                        Scrdsr.x = 65 - x;
                        Scrdsr.y = 50;
                        SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                        if (SCFlg) {
                            if (Mode == 1) {
                                Scrsrc.x = 140;
                                Scrsrc.y = 245;
                                Scrsrc.w = 200;
                                Scrsrc.h = 50;
                                Scrdsr.x = 140 - x;
                                Scrdsr.y = 125;
                                SDL_BlitSurface(ModeImage, &Scrsrc, screen, &Scrdsr);
                            } else if (Mode == 2) {
                                Scrsrc.x = 140;
                                Scrsrc.y = 345;
                                Scrsrc.w = 200;
                                Scrsrc.h = 50;
                                Scrdsr.x = 140 - x;
                                Scrdsr.y = 125;
                                SDL_BlitSurface(ModeImage, &Scrsrc, screen, &Scrdsr);
                            } else {
                                Scrsrc.x = 140;
                                Scrsrc.y = 295;
                                Scrsrc.w = 200;
                                Scrsrc.h = 50;
                                Scrdsr.x = 140 - x;
                                Scrdsr.y = 125;
                                SDL_BlitSurface(ModeImage, &Scrsrc, screen, &Scrdsr);
                            }
                        } else {
                            if (Mode == 1) {
                                Scrsrc.x = 140;
                                Scrsrc.y = 245;
                                Scrsrc.w = 200;
                                Scrsrc.h = 50;
                                Scrdsr.x = 140 - x;
                                Scrdsr.y = 125;
                                SDL_BlitSurface(ModeImage, &Scrsrc, screen, &Scrdsr);
                            } else {
                                Scrsrc.x = 140;
                                Scrsrc.y = 345;
                                Scrsrc.w = 200;
                                Scrsrc.h = 50;
                                Scrdsr.x = 140 - x;
                                Scrdsr.y = 125;
                                SDL_BlitSurface(ModeImage, &Scrsrc, screen, &Scrdsr);
                            }
                        }
                        for (i = 0; i < 5; i++) {
                            Scrsrc.x = (i + 1)*50;
                            Scrsrc.y = 75;
                            Scrsrc.w = 50;
                            Scrsrc.h = 50;
                            Scrdsr.x = 80 - x;
                            Scrdsr.y = 180 + i * 50;
                            SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                            if (i + 1 == 1) {
                                Scrsrc.x = 50;
                                Scrsrc.y = 125;
                                Scrsrc.w = 50;
                                Scrsrc.h = 50;
                                Scrdsr.x = 110 - x;
                                Scrdsr.y = 180 + i * 50;
                                SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                            } else if (i + 1 == 2) {
                                Scrsrc.x = 100;
                                Scrsrc.y = 125;
                                Scrsrc.w = 50;
                                Scrsrc.h = 50;
                                Scrdsr.x = 110 - x;
                                Scrdsr.y = 180 + i * 50;
                                SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                            } else if (i + 1 == 3) {
                                Scrsrc.x = 150;
                                Scrsrc.y = 125;
                                Scrsrc.w = 50;
                                Scrsrc.h = 50;
                                Scrdsr.x = 110 - x;
                                Scrdsr.y = 180 + i * 50;
                                SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                            } else {
                                Scrsrc.x = 200;
                                Scrsrc.y = 125;
                                Scrsrc.w = 50;
                                Scrsrc.h = 50;
                                Scrdsr.x = 110 - x;
                                Scrdsr.y = 180 + i * 50;
                                SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                            }
                            if (Mode == 1) {
                                w = Ranking[i];
                                if (EFlg && w == scr) {
                                    Scrsrc.x = 100;
                                    Scrsrc.y = 275;
                                    Scrsrc.w = 75;
                                    Scrsrc.h = 38;
                                    Scrdsr.x = -x;
                                    Scrdsr.y = 180 + i * 50;
                                    SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                                }
                            } else if (Mode == 2) {
                                w = Ranking[i + 5];
                                if (!MFlg && !EFlg && w == scr) {
                                    Scrsrc.x = 100;
                                    Scrsrc.y = 275;
                                    Scrsrc.w = 75;
                                    Scrsrc.h = 38;
                                    Scrdsr.x = -x;
                                    Scrdsr.y = 180 + i * 50;
                                    SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                                }
                            } else {
                                w = Ranking[i + 10];
                                if (MFlg && w == scr) {
                                    Scrsrc.x = 100;
                                    Scrsrc.y = 275;
                                    Scrsrc.w = 75;
                                    Scrsrc.h = 38;
                                    Scrdsr.x = -x;
                                    Scrdsr.y = 180 + i * 50;
                                    SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                                }
                            }
                            for (j = 10000, l = 0; j >= 1; j /= 10, l++) {
                                Scrsrc.x = (w / j)*50;
                                Scrsrc.y = 75;
                                Scrsrc.w = 50;
                                Scrsrc.h = 50;
                                Scrdsr.x = 160 + l * 40 - x;
                                Scrdsr.y = 180 + i * 50;
                                SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                                w %= j;
                            }
                            Scrsrc.x = 250;
                            Scrsrc.y = 125;
                            Scrsrc.w = 50;
                            Scrsrc.h = 50;
                            Scrdsr.x = 302 - x;
                            Scrdsr.y = 180 + i * 50;
                            SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                            Scrsrc.x = 0;
                            Scrsrc.y = 125;
                            Scrsrc.w = 50;
                            Scrsrc.h = 50;
                            Scrdsr.x = 360 - x;
                            Scrdsr.y = 180 + i * 50;
                            SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                        }
                        Scrsrc.x = 0;
                        Scrsrc.y = 175;
                        Scrsrc.w = 350;
                        Scrsrc.h = 75;
                        Scrdsr.x = 480 + 65 - x;
                        Scrdsr.y = 50;
                        SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                        if (SCFlg) {
                            if (Mode == 1) {
                                Scrsrc.x = 140;
                                Scrsrc.y = 345;
                                Scrsrc.w = 200;
                                Scrsrc.h = 50;
                                Scrdsr.x = 480 + 140 - x;
                                Scrdsr.y = 125;
                                SDL_BlitSurface(ModeImage, &Scrsrc, screen, &Scrdsr);
                            } else if (Mode == 2) {
                                Scrsrc.x = 140;
                                Scrsrc.y = 295;
                                Scrsrc.w = 200;
                                Scrsrc.h = 50;
                                Scrdsr.x = 480 + 140 - x;
                                Scrdsr.y = 125;
                                SDL_BlitSurface(ModeImage, &Scrsrc, screen, &Scrdsr);
                            } else {
                                Scrsrc.x = 140;
                                Scrsrc.y = 245;
                                Scrsrc.w = 200;
                                Scrsrc.h = 50;
                                Scrdsr.x = 480 + 140 - x;
                                Scrdsr.y = 125;
                                SDL_BlitSurface(ModeImage, &Scrsrc, screen, &Scrdsr);
                            }
                        } else {
                            if (Mode == 1) {
                                Scrsrc.x = 140;
                                Scrsrc.y = 345;
                                Scrsrc.w = 200;
                                Scrsrc.h = 50;
                                Scrdsr.x = 480 + 140 - x;
                                Scrdsr.y = 125;
                                SDL_BlitSurface(ModeImage, &Scrsrc, screen, &Scrdsr);
                            } else {
                                Scrsrc.x = 140;
                                Scrsrc.y = 245;
                                Scrsrc.w = 200;
                                Scrsrc.h = 50;
                                Scrdsr.x = 480 + 140 - x;
                                Scrdsr.y = 125;
                                SDL_BlitSurface(ModeImage, &Scrsrc, screen, &Scrdsr);
                            }
                        }
                        for (i = 0; i < 5; i++) {
                            Scrsrc.x = (i + 1)*50;
                            Scrsrc.y = 75;
                            Scrsrc.w = 50;
                            Scrsrc.h = 50;
                            Scrdsr.x = 480 + 80 - x;
                            Scrdsr.y = 180 + i * 50;
                            SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                            if (i + 1 == 1) {
                                Scrsrc.x = 50;
                                Scrsrc.y = 125;
                                Scrsrc.w = 50;
                                Scrsrc.h = 50;
                                Scrdsr.x = 480 + 110 - x;
                                Scrdsr.y = 180 + i * 50;
                                SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                            } else if (i + 1 == 2) {
                                Scrsrc.x = 100;
                                Scrsrc.y = 125;
                                Scrsrc.w = 50;
                                Scrsrc.h = 50;
                                Scrdsr.x = 480 + 110 - x;
                                Scrdsr.y = 180 + i * 50;
                                SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                            } else if (i + 1 == 3) {
                                Scrsrc.x = 150;
                                Scrsrc.y = 125;
                                Scrsrc.w = 50;
                                Scrsrc.h = 50;
                                Scrdsr.x = 480 + 110 - x;
                                Scrdsr.y = 180 + i * 50;
                                SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                            } else {
                                Scrsrc.x = 200;
                                Scrsrc.y = 125;
                                Scrsrc.w = 50;
                                Scrsrc.h = 50;
                                Scrdsr.x = 480 + 110 - x;
                                Scrdsr.y = 180 + i * 50;
                                SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                            }
                            if (SCFlg) {
                                if (Mode == 1) {
                                    w = Ranking[i + 5];
                                    if (!MFlg && !EFlg && w == scr) {
                                        Scrsrc.x = 100;
                                        Scrsrc.y = 275;
                                        Scrsrc.w = 75;
                                        Scrsrc.h = 38;
                                        Scrdsr.x = 480 - x;
                                        Scrdsr.y = 185 + i * 50;
                                        SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                                    }
                                } else if (Mode == 2) {
                                    w = Ranking[i + 10];
                                    if (MFlg && w == scr) {
                                        Scrsrc.x = 100;
                                        Scrsrc.y = 275;
                                        Scrsrc.w = 75;
                                        Scrsrc.h = 38;
                                        Scrdsr.x = 480 - x;
                                        Scrdsr.y = 185 + i * 50;
                                        SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                                    }
                                } else {
                                    w = Ranking[i];
                                    if (EFlg && w == scr) {
                                        Scrsrc.x = 100;
                                        Scrsrc.y = 275;
                                        Scrsrc.w = 75;
                                        Scrsrc.h = 38;
                                        Scrdsr.x = 480 - x;
                                        Scrdsr.y = 185 + i * 50;
                                        SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                                    }
                                }
                            } else {
                                if (Mode == 1) {
                                    w = Ranking[i + 5];
                                    if (!MFlg && !EFlg && w == scr) {
                                        Scrsrc.x = 100;
                                        Scrsrc.y = 275;
                                        Scrsrc.w = 75;
                                        Scrsrc.h = 38;
                                        Scrdsr.x = 480 - x;
                                        Scrdsr.y = 185 + i * 50;
                                        SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                                    }
                                } else {
                                    w = Ranking[i];
                                    if (EFlg && w == scr) {
                                        Scrsrc.x = 100;
                                        Scrsrc.y = 275;
                                        Scrsrc.w = 75;
                                        Scrsrc.h = 38;
                                        Scrdsr.x = 480 - x;
                                        Scrdsr.y = 185 + i * 50;
                                        SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                                    }
                                }
                            }
                            for (j = 10000, l = 0; j >= 1; j /= 10, l++) {
                                Scrsrc.x = (w / j)*50;
                                Scrsrc.y = 75;
                                Scrsrc.w = 50;
                                Scrsrc.h = 50;
                                Scrdsr.x = 480 + 160 + l * 40 - x;
                                Scrdsr.y = 185 + i * 50;
                                SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                                w %= j;
                            }
                            Scrsrc.x = 250;
                            Scrsrc.y = 125;
                            Scrsrc.w = 50;
                            Scrsrc.h = 50;
                            Scrdsr.x = 480 + 302 - x;
                            Scrdsr.y = 185 + i * 50;
                            SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                            Scrsrc.x = 0;
                            Scrsrc.y = 125;
                            Scrsrc.w = 50;
                            Scrsrc.h = 50;
                            Scrdsr.x = 480 + 360 - x;
                            Scrdsr.y = 180 + i * 50;
                            SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                        }
                    } else {
                        //ランキングデータ表示
                        Scrsrc.x = 0;
                        Scrsrc.y = 175;
                        Scrsrc.w = 350;
                        Scrsrc.h = 75;
                        Scrdsr.x = 65;
                        Scrdsr.y = 50;
                        SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                        if (Mode == 1) { //エンドレス
                            Scrsrc.x = 140;
                            Scrsrc.y = 245;
                            Scrsrc.w = 200;
                            Scrsrc.h = 50;
                            Scrdsr.x = 140;
                            Scrdsr.y = 125;
                            SDL_BlitSurface(ModeImage, &Scrsrc, screen, &Scrdsr);
                            for (i = 0; i < 5; i++) {
                                Scrsrc.x = (i + 1)*50;
                                Scrsrc.y = 75;
                                Scrsrc.w = 50;
                                Scrsrc.h = 50;
                                Scrdsr.x = 80;
                                Scrdsr.y = 180 + i * 50;
                                SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                                if (i + 1 == 1) {
                                    Scrsrc.x = 50;
                                    Scrsrc.y = 125;
                                    Scrsrc.w = 50;
                                    Scrsrc.h = 50;
                                    Scrdsr.x = 110;
                                    Scrdsr.y = 180 + i * 50;
                                    SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                                } else if (i + 1 == 2) {
                                    Scrsrc.x = 100;
                                    Scrsrc.y = 125;
                                    Scrsrc.w = 50;
                                    Scrsrc.h = 50;
                                    Scrdsr.x = 110;
                                    Scrdsr.y = 180 + i * 50;
                                    SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                                } else if (i + 1 == 3) {
                                    Scrsrc.x = 150;
                                    Scrsrc.y = 125;
                                    Scrsrc.w = 50;
                                    Scrsrc.h = 50;
                                    Scrdsr.x = 110;
                                    Scrdsr.y = 180 + i * 50;
                                    SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                                } else {
                                    Scrsrc.x = 200;
                                    Scrsrc.y = 125;
                                    Scrsrc.w = 50;
                                    Scrsrc.h = 50;
                                    Scrdsr.x = 110;
                                    Scrdsr.y = 180 + i * 50;
                                    SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                                }
                                w = Ranking[i];
                                if (EFlg && w == scr) {
                                    Scrsrc.x = 100;
                                    Scrsrc.y = 275;
                                    Scrsrc.w = 75;
                                    Scrsrc.h = 38;
                                    Scrdsr.x = 0;
                                    Scrdsr.y = 180 + i * 50;
                                    SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                                }
                                for (j = 10000, l = 0; j >= 1; j /= 10, l++) {
                                    Scrsrc.x = (w / j)*50;
                                    Scrsrc.y = 75;
                                    Scrsrc.w = 50;
                                    Scrsrc.h = 50;
                                    Scrdsr.x = 160 + l * 40;
                                    Scrdsr.y = 180 + i * 50;
                                    SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                                    w %= j;
                                }
                                Scrsrc.x = 250;
                                Scrsrc.y = 125;
                                Scrsrc.w = 50;
                                Scrsrc.h = 50;
                                Scrdsr.x = 302;
                                Scrdsr.y = 180 + i * 50;
                                SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                                Scrsrc.x = 0;
                                Scrsrc.y = 125;
                                Scrsrc.w = 50;
                                Scrsrc.h = 50;
                                Scrdsr.x = 360;
                                Scrdsr.y = 180 + i * 50;
                                SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                            }
                        } else if (Mode == 2) { //ワンミニッツ
                            Scrsrc.x = 140;
                            Scrsrc.y = 345;
                            Scrsrc.w = 200;
                            Scrsrc.h = 50;
                            Scrdsr.x = 140;
                            Scrdsr.y = 125;
                            SDL_BlitSurface(ModeImage, &Scrsrc, screen, &Scrdsr);
                            for (i = 0; i < 5; i++) {
                                Scrsrc.x = (i + 1)*50;
                                Scrsrc.y = 75;
                                Scrsrc.w = 50;
                                Scrsrc.h = 50;
                                Scrdsr.x = 80;
                                Scrdsr.y = 180 + i * 50;
                                SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                                if (i + 1 == 1) {
                                    Scrsrc.x = 50;
                                    Scrsrc.y = 125;
                                    Scrsrc.w = 50;
                                    Scrsrc.h = 50;
                                    Scrdsr.x = 110;
                                    Scrdsr.y = 180 + i * 50;
                                    SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                                } else if (i + 1 == 2) {
                                    Scrsrc.x = 100;
                                    Scrsrc.y = 125;
                                    Scrsrc.w = 50;
                                    Scrsrc.h = 50;
                                    Scrdsr.x = 110;
                                    Scrdsr.y = 180 + i * 50;
                                    SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                                } else if (i + 1 == 3) {
                                    Scrsrc.x = 150;
                                    Scrsrc.y = 125;
                                    Scrsrc.w = 50;
                                    Scrsrc.h = 50;
                                    Scrdsr.x = 110;
                                    Scrdsr.y = 180 + i * 50;
                                    SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                                } else {
                                    Scrsrc.x = 200;
                                    Scrsrc.y = 125;
                                    Scrsrc.w = 50;
                                    Scrsrc.h = 50;
                                    Scrdsr.x = 110;
                                    Scrdsr.y = 180 + i * 50;
                                    SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                                }
                                w = Ranking[i + 5];
                                if (!MFlg && !EFlg && w == scr) {
                                    Scrsrc.x = 100;
                                    Scrsrc.y = 275;
                                    Scrsrc.w = 75;
                                    Scrsrc.h = 38;
                                    Scrdsr.x = 0;
                                    Scrdsr.y = 185 + i * 50;
                                    SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                                }
                                for (j = 10000, l = 0; j >= 1; j /= 10, l++) {
                                    Scrsrc.x = (w / j)*50;
                                    Scrsrc.y = 75;
                                    Scrsrc.w = 50;
                                    Scrsrc.h = 50;
                                    Scrdsr.x = 160 + l * 40;
                                    Scrdsr.y = 180 + i * 50;
                                    SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                                    w %= j;
                                }
                                Scrsrc.x = 250;
                                Scrsrc.y = 125;
                                Scrsrc.w = 50;
                                Scrsrc.h = 50;
                                Scrdsr.x = 302;
                                Scrdsr.y = 185 + i * 50;
                                SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                                Scrsrc.x = 0;
                                Scrsrc.y = 125;
                                Scrsrc.w = 50;
                                Scrsrc.h = 50;
                                Scrdsr.x = 360;
                                Scrdsr.y = 180 + i * 50;
                                SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                            }
                        } else { //ミラー
                            Scrsrc.x = 140;
                            Scrsrc.y = 295;
                            Scrsrc.w = 200;
                            Scrsrc.h = 50;
                            Scrdsr.x = 140;
                            Scrdsr.y = 125;
                            SDL_BlitSurface(ModeImage, &Scrsrc, screen, &Scrdsr);
                            for (i = 0; i < 5; i++) {
                                Scrsrc.x = (i + 1)*50;
                                Scrsrc.y = 75;
                                Scrsrc.w = 50;
                                Scrsrc.h = 50;
                                Scrdsr.x = 80;
                                Scrdsr.y = 180 + i * 50;
                                SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                                if (i + 1 == 1) {
                                    Scrsrc.x = 50;
                                    Scrsrc.y = 125;
                                    Scrsrc.w = 50;
                                    Scrsrc.h = 50;
                                    Scrdsr.x = 110;
                                    Scrdsr.y = 180 + i * 50;
                                    SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                                } else if (i + 1 == 2) {
                                    Scrsrc.x = 100;
                                    Scrsrc.y = 125;
                                    Scrsrc.w = 50;
                                    Scrsrc.h = 50;
                                    Scrdsr.x = 110;
                                    Scrdsr.y = 180 + i * 50;
                                    SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                                } else if (i + 1 == 3) {
                                    Scrsrc.x = 150;
                                    Scrsrc.y = 125;
                                    Scrsrc.w = 50;
                                    Scrsrc.h = 50;
                                    Scrdsr.x = 110;
                                    Scrdsr.y = 180 + i * 50;
                                    SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                                } else {
                                    Scrsrc.x = 200;
                                    Scrsrc.y = 125;
                                    Scrsrc.w = 50;
                                    Scrsrc.h = 50;
                                    Scrdsr.x = 110;
                                    Scrdsr.y = 180 + i * 50;
                                    SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                                }
                                w = Ranking[i + 10];
                                if (MFlg && w == scr) {
                                    Scrsrc.x = 100;
                                    Scrsrc.y = 275;
                                    Scrsrc.w = 75;
                                    Scrsrc.h = 38;
                                    Scrdsr.x = 0;
                                    Scrdsr.y = 185 + i * 50;
                                    SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                                }
                                for (j = 10000, l = 0; j >= 1; j /= 10, l++) {
                                    Scrsrc.x = (w / j)*50;
                                    Scrsrc.y = 75;
                                    Scrsrc.w = 50;
                                    Scrsrc.h = 50;
                                    Scrdsr.x = 160 + l * 40;
                                    Scrdsr.y = 180 + i * 50;
                                    SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                                    w %= j;
                                }
                                Scrsrc.x = 250;
                                Scrsrc.y = 125;
                                Scrsrc.w = 50;
                                Scrsrc.h = 50;
                                Scrdsr.x = 302;
                                Scrdsr.y = 185 + i * 50;
                                SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                                Scrsrc.x = 0;
                                Scrsrc.y = 125;
                                Scrsrc.w = 50;
                                Scrsrc.h = 50;
                                Scrdsr.x = 360;
                                Scrdsr.y = 180 + i * 50;
                                SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                            }
                        }
                    }
                } else {
                    //ランキングデータ表示
                    Scrsrc.x = 0;
                    Scrsrc.y = 175;
                    Scrsrc.w = 350;
                    Scrsrc.h = 75;
                    Scrdsr.x = 65;
                    Scrdsr.y = 50;
                    SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                    if (Mode == 1) { //エンドレス
                        Scrsrc.x = 140;
                        Scrsrc.y = 245;
                        Scrsrc.w = 200;
                        Scrsrc.h = 50;
                        Scrdsr.x = 140;
                        Scrdsr.y = 125;
                        SDL_BlitSurface(ModeImage, &Scrsrc, screen, &Scrdsr);
                        for (i = 0; i < 5; i++) {
                            Scrsrc.x = (i + 1)*50;
                            Scrsrc.y = 75;
                            Scrsrc.w = 50;
                            Scrsrc.h = 50;
                            Scrdsr.x = 80;
                            Scrdsr.y = 180 + i * 50;
                            SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                            if (i + 1 == 1) {
                                Scrsrc.x = 50;
                                Scrsrc.y = 125;
                                Scrsrc.w = 50;
                                Scrsrc.h = 50;
                                Scrdsr.x = 110;
                                Scrdsr.y = 180 + i * 50;
                                SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                            } else if (i + 1 == 2) {
                                Scrsrc.x = 100;
                                Scrsrc.y = 125;
                                Scrsrc.w = 50;
                                Scrsrc.h = 50;
                                Scrdsr.x = 110;
                                Scrdsr.y = 180 + i * 50;
                                SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                            } else if (i + 1 == 3) {
                                Scrsrc.x = 150;
                                Scrsrc.y = 125;
                                Scrsrc.w = 50;
                                Scrsrc.h = 50;
                                Scrdsr.x = 110;
                                Scrdsr.y = 180 + i * 50;
                                SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                            } else {
                                Scrsrc.x = 200;
                                Scrsrc.y = 125;
                                Scrsrc.w = 50;
                                Scrsrc.h = 50;
                                Scrdsr.x = 110;
                                Scrdsr.y = 180 + i * 50;
                                SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                            }
                            w = Ranking[i];
                            if (EFlg && w == scr) {
                                Scrsrc.x = 100;
                                Scrsrc.y = 275;
                                Scrsrc.w = 75;
                                Scrsrc.h = 38;
                                Scrdsr.x = 0;
                                Scrdsr.y = 185 + i * 50;
                                SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                            }
                            for (j = 10000, l = 0; j >= 1; j /= 10, l++) {
                                Scrsrc.x = (w / j)*50;
                                Scrsrc.y = 75;
                                Scrsrc.w = 50;
                                Scrsrc.h = 50;
                                Scrdsr.x = 160 + l * 40;
                                Scrdsr.y = 180 + i * 50;
                                SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                                w %= j;
                            }
                            Scrsrc.x = 250;
                            Scrsrc.y = 125;
                            Scrsrc.w = 50;
                            Scrsrc.h = 50;
                            Scrdsr.x = 302;
                            Scrdsr.y = 185 + i * 50;
                            SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                            Scrsrc.x = 0;
                            Scrsrc.y = 125;
                            Scrsrc.w = 50;
                            Scrsrc.h = 50;
                            Scrdsr.x = 360;
                            Scrdsr.y = 180 + i * 50;
                            SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                        }
                    } else if (Mode == 2) { //ワンミニッツ
                        Scrsrc.x = 140;
                        Scrsrc.y = 345;
                        Scrsrc.w = 200;
                        Scrsrc.h = 50;
                        Scrdsr.x = 140;
                        Scrdsr.y = 125;
                        SDL_BlitSurface(ModeImage, &Scrsrc, screen, &Scrdsr);
                        for (i = 0; i < 5; i++) {
                            Scrsrc.x = (i + 1)*50;
                            Scrsrc.y = 75;
                            Scrsrc.w = 50;
                            Scrsrc.h = 50;
                            Scrdsr.x = 80;
                            Scrdsr.y = 180 + i * 50;
                            SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                            if (i + 1 == 1) {
                                Scrsrc.x = 50;
                                Scrsrc.y = 125;
                                Scrsrc.w = 50;
                                Scrsrc.h = 50;
                                Scrdsr.x = 110;
                                Scrdsr.y = 180 + i * 50;
                                SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                            } else if (i + 1 == 2) {
                                Scrsrc.x = 100;
                                Scrsrc.y = 125;
                                Scrsrc.w = 50;
                                Scrsrc.h = 50;
                                Scrdsr.x = 110;
                                Scrdsr.y = 180 + i * 50;
                                SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                            } else if (i + 1 == 3) {
                                Scrsrc.x = 150;
                                Scrsrc.y = 125;
                                Scrsrc.w = 50;
                                Scrsrc.h = 50;
                                Scrdsr.x = 110;
                                Scrdsr.y = 180 + i * 50;
                                SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                            } else {
                                Scrsrc.x = 200;
                                Scrsrc.y = 125;
                                Scrsrc.w = 50;
                                Scrsrc.h = 50;
                                Scrdsr.x = 110;
                                Scrdsr.y = 180 + i * 50;
                                SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                            }
                            w = Ranking[i + 5];
                            if (!MFlg && !EFlg && w == scr) {
                                Scrsrc.x = 100;
                                Scrsrc.y = 275;
                                Scrsrc.w = 75;
                                Scrsrc.h = 38;
                                Scrdsr.x = 0;
                                Scrdsr.y = 185 + i * 50;
                                SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                            }
                            for (j = 10000, l = 0; j >= 1; j /= 10, l++) {
                                Scrsrc.x = (w / j)*50;
                                Scrsrc.y = 75;
                                Scrsrc.w = 50;
                                Scrsrc.h = 50;
                                Scrdsr.x = 160 + l * 40;
                                Scrdsr.y = 180 + i * 50;
                                SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                                w %= j;
                            }
                            Scrsrc.x = 250;
                            Scrsrc.y = 125;
                            Scrsrc.w = 50;
                            Scrsrc.h = 50;
                            Scrdsr.x = 302;
                            Scrdsr.y = 185 + i * 50;
                            SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                            Scrsrc.x = 0;
                            Scrsrc.y = 125;
                            Scrsrc.w = 50;
                            Scrsrc.h = 50;
                            Scrdsr.x = 360;
                            Scrdsr.y = 180 + i * 50;
                            SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                        }
                    } else { //ミラー
                        Scrsrc.x = 140;
                        Scrsrc.y = 295;
                        Scrsrc.w = 200;
                        Scrsrc.h = 50;
                        Scrdsr.x = 140;
                        Scrdsr.y = 125;
                        SDL_BlitSurface(ModeImage, &Scrsrc, screen, &Scrdsr);
                        for (i = 0; i < 5; i++) {
                            Scrsrc.x = (i + 1)*50;
                            Scrsrc.y = 75;
                            Scrsrc.w = 50;
                            Scrsrc.h = 50;
                            Scrdsr.x = 80;
                            Scrdsr.y = 180 + i * 50;
                            SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                            if (i + 1 == 1) {
                                Scrsrc.x = 50;
                                Scrsrc.y = 125;
                                Scrsrc.w = 50;
                                Scrsrc.h = 50;
                                Scrdsr.x = 110;
                                Scrdsr.y = 180 + i * 50;
                                SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                            } else if (i + 1 == 2) {
                                Scrsrc.x = 100;
                                Scrsrc.y = 125;
                                Scrsrc.w = 50;
                                Scrsrc.h = 50;
                                Scrdsr.x = 110;
                                Scrdsr.y = 180 + i * 50;
                                SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                            } else if (i + 1 == 3) {
                                Scrsrc.x = 150;
                                Scrsrc.y = 125;
                                Scrsrc.w = 50;
                                Scrsrc.h = 50;
                                Scrdsr.x = 110;
                                Scrdsr.y = 180 + i * 50;
                                SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                            } else {
                                Scrsrc.x = 200;
                                Scrsrc.y = 125;
                                Scrsrc.w = 50;
                                Scrsrc.h = 50;
                                Scrdsr.x = 110;
                                Scrdsr.y = 180 + i * 50;
                                SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                            }
                            w = Ranking[i + 10];
                            if (MFlg && w == scr) {
                                Scrsrc.x = 100;
                                Scrsrc.y = 275;
                                Scrsrc.w = 75;
                                Scrsrc.h = 38;
                                Scrdsr.x = 0;
                                Scrdsr.y = 185 + i * 50;
                                SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                            }
                            for (j = 10000, l = 0; j >= 1; j /= 10, l++) {
                                Scrsrc.x = (w / j)*50;
                                Scrsrc.y = 75;
                                Scrsrc.w = 50;
                                Scrsrc.h = 50;
                                Scrdsr.x = 160 + l * 40;
                                Scrdsr.y = 180 + i * 50;
                                SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                                w %= j;
                            }
                            Scrsrc.x = 250;
                            Scrsrc.y = 125;
                            Scrsrc.w = 50;
                            Scrsrc.h = 50;
                            Scrdsr.x = 302;
                            Scrdsr.y = 185 + i * 50;
                            SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                            Scrsrc.x = 0;
                            Scrsrc.y = 125;
                            Scrsrc.w = 50;
                            Scrsrc.h = 50;
                            Scrdsr.x = 360;
                            Scrdsr.y = 180 + i * 50;
                            SDL_BlitSurface(RankImage, &Scrsrc, screen, &Scrdsr);
                        }
                    }
                }

                break;

            case YES_NO:

                if (KeyFlg.Up == 1) {
                    KeyFlg.Up = 2;
                    _select--;
                    if (_select < 0) {
                        _select = 1;
                    }
                }
                if (KeyFlg.Down == 1) {
                    KeyFlg.Down = 2;
                    _select++;
                    if (_select > 1) {
                        _select = 0;
                    }
                }
                if (KeyFlg.Select == 1) {
                    KeyFlg.Select = 2;
                    if (_select == 0) {
                        GameScene = RANKING;
                        _select = 0;
                    } else {
                        RankingDelete();
                        GameScene = OK;
                        _select = 0;
                    }
                }
                ball.dsr.x = 140;
                ball.dsr.y = 255 + _select * 100 + 10;
                SDL_BlitSurface(Bimage, &ball.src, screen, &ball.dsr);
                SDL_BlitSurface(YesNoImage, &src1, screen, &dsr1);
                Draw_Rect(v_vram, 158, 255 + _select * 100, 164, 33, red);
                break;

            case OK:

                if (KeyFlg.Select == 1) {
                    KeyFlg.Select = 2;
                    GameScene = RANKING;
                }

                SDL_BlitSurface(OkImage, &src1, screen, &dsr1);
                break;

            case HELP:
                if (KeyFlg.Up == 1) {
                    KeyFlg.Up = 2;
                    _select--;
                    if (_select < 0) {
                        _select = 1;
                    }
                }
                if (KeyFlg.Down == 1) {
                    KeyFlg.Down = 2;
                    _select++;
                    if (_select > 1) {
                        _select = 0;
                    }
                }
                if (KeyFlg.Select == 1) {
                    KeyFlg.Select = 2;
                    if (_select == 0) {
                        GameScene = HELP_2;
                        _select = 0;
                    } else if (_select == 1) {
                        GameScene = HELP_3;
                        _select = 0;
                    }
                }
                if (KeyFlg.Return == 1) {
                    KeyFlg.Return = 2;
                    _select = 0;
                    GameScene = TITLE;
                }
                ball.dsr.x = 140;
                ball.dsr.y = 260 + ball.Height / 2 + _select * 100;
                SDL_BlitSurface(Bimage, &ball.src, screen, &ball.dsr);
                SDL_BlitSurface(HelpImage, &src1, screen, &dsr1);
                Draw_Rect(v_vram, 158, 256 + _select * 100, 170, 33, red);
                break;

            case HELP_2:

                if (KeyFlg.Select == 1) {
                    KeyFlg.Select = 2;
                    _select = 0;
                    GameScene = HELP;
                }
                if (KeyFlg.Return == 1) {
                    KeyFlg.Return = 2;
                    _select = 0;
                    GameScene = TITLE;
                }
                SDL_BlitSurface(HelpImage2, &src1, screen, &dsr1);
                break;

            case HELP_3:

                if (KeyFlg.Select == 1) {
                    KeyFlg.Select = 2;
                    _select = 0;
                    GameScene = HELP;
                }
                if (KeyFlg.Return == 1) {
                    KeyFlg.Return = 2;
                    _select = 0;
                    GameScene = TITLE;
                }
                SDL_BlitSurface(HelpImage3_2, &src1, screen, &dsr1);
                break;
        }

        SDL_Flip(screen);

        fps_wait();
        //fps_no();
    }

    SDL_FreeSurface(screen);
    SDL_FreeSurface(Bimage);
    SDL_FreeSurface(Simage);
    SDL_FreeSurface(Simage2);
    SDL_FreeSurface(SWimage);
    SDL_FreeSurface(SWimage2);
    SDL_FreeSurface(TitleImage);
    SDL_FreeSurface(RankImage);
    SDL_FreeSurface(ModeImage);
    SDL_FreeSurface(HelpImage);
    SDL_FreeSurface(HelpImage2);
    SDL_FreeSurface(HelpImage3_2);
    SDL_FreeSurface(YesNoImage);
    SDL_FreeSurface(OkImage);
    SDL_FreeSurface(v_vram);

    printf("OFF\n");
    SDL_Quit();
    return 0;
}

//ボールがシーソー上かどうかを判定

int SeesawHit(BALL b, SEESAW s[], int kosuu) {
    int i;
    for (i = 0; i < kosuu; i++) {
        if (s[i].MFlg == 0) {
            if (Ang == 0) {
                if ((b.x + b.Width / 2) >= s[i].left_x && (b.x - b.Width / 2) <= s[i].right_x && (b.y + b.Height / 2) >= s[i].right_y && (b.y + b.Height / 2) <= (s[i].right_y + s[i].Height)) {
                    return i;
                }
            } else if (Ang > 0) {
                if ((b.x + b.Width / 2) >= s[i].left_x && (b.x - b.Width / 2) <= s[i].right_x && (b.y + b.Height / 2) >= s[i].left_y && (b.y + b.Height / 2) <= s[i].right_y) {
                    return i;
                }
            } else {
                if ((b.x + b.Width / 2) >= s[i].left_x && (b.x - b.Width / 2) <= s[i].right_x && (b.y + b.Height / 2) <= s[i].left_y && (b.y + b.Height / 2) >= s[i].right_y) {
                    return i;
                }
            }
        } else {
            if (Ang == 0) {
                if ((b.x + b.Width / 2) >= s[i].left_x && (b.x - b.Width / 2) <= s[i].right_x && (b.y + b.Height / 2) >= s[i].right_y && (b.y + b.Height / 2) <= (s[i].right_y + s[i].Height)) {
                    return i;
                }
            } else if (Ang < 0) {
                if ((b.x + b.Width / 2) >= s[i].left_x && (b.x - b.Width / 2) <= s[i].right_x && (b.y + b.Height / 2) >= s[i].left_y && (b.y + b.Height / 2) <= s[i].right_y) {
                    return i;
                }
            } else {
                if ((b.x + b.Width / 2) >= s[i].left_x && (b.x - b.Width / 2) <= s[i].right_x && (b.y + b.Height / 2) <= s[i].left_y && (b.y + b.Height / 2) >= s[i].right_y) {
                    return i;
                }
            }
        }
    }
    return -1;
}

void BallInit(void) {
    ball.x = 30;
    ball.y = 0;
    ball.vx = 0;
    ball.vy = 0;
    ball.Width = 15;
    ball.Height = 15;
    ball.SFlg = 0;
    ball.color = 0;
    ball.src.x = 0;
    ball.src.y = 0;
    ball.src.h = 15;
    ball.src.w = 15;
}

void RankingInit(void) {
    FILE *fp;
    int i;
    fp = fopen("ranking.txt", "r");
    for (i = 0; i < 15; i++) {
        fscanf(fp, "%d\n", &Ranking[i]);
    }
    fclose(fp);
}

//ランキングデータ更新

void RankingJudge(short EFlg, short MFlg, int scr) {
    FILE *fp;
    int data[5]; //ランキングデータ
    int i, j, k; //ループ用
    int Flg = 0; //更新された時に1に
    int w; //作業用

    for (i = 0; i < 5; i++) {
        if (MFlg) {
            data[i] = Ranking[i + 10];
        } else if (EFlg) {
            data[i] = Ranking[i];
        } else {
            data[i] = Ranking[i + 5];
        }
    }

    //更新されているか
    for (i = 4; (i >= 0) && (data[i] <= scr); i--) {
        data[i + 1] = data[i];
        data[i] = scr;
        Flg = 1;
    }

    //更新されていたらデータを反映し確認を表示
    if (Flg) {

        for (k = 0; k < 5; k++) {
            //モードに対応したデータを文字列に変換
            if (MFlg) {
                Ranking[k + 10] = data[k];
            } else if (EFlg) {
                Ranking[k] = data[k];
            } else {
                Ranking[k + 5] = data[k];
            }
        }

        fp = fopen("ranking.txt", "w");
        for (i = 0; i < 15; i++) {
            fprintf(fp, "%d\n", Ranking[i]);
        }
        fclose(fp);
        return;

    }

}

void RankingDelete(void) {

    FILE *fp;
    int i;
    fp = fopen("d_ranking.txt", "r");
    for (i = 0; i < 15; i++) {
        fscanf(fp, "%d", &Ranking[i]);
    }
    fclose(fp);
    fp = fopen("ranking.txt", "w");
    for (i = 0; i < 15; i++) {
        fprintf(fp, "%d\n", Ranking[i]);
    }
    fclose(fp);

}

void LoadMap(void) {
    FILE *fp;
    int i, k = 0;
    fp = fopen("map.txt", "r");
    fscanf(fp, "%d", &kosuu);
    for (i = 0; i < kosuu; i++) {
        fscanf(fp, "%f%f", &s[i].x, &s[i].y);
        s[i].Height = 17;
        s[i].Width = 128;
        s[i].left_x = s[i].x - s[i].Width / 2;
        s[i].left_y = s[i].y - s[i].Height / 2;
        s[i].right_x = s[i].x + s[i].Width / 2;
        s[i].right_y = s[i].y - s[i].Height / 2;
        s[i].MFlg = 0;
        s[i].src.x = 0;
        s[i].src.y = 0;
        s[i].src.h = 128;
        s[i].src.w = 128;
    }
    fclose(fp);
}

void fps_wait(void) {
    unsigned int now_time, left_time;
    static unsigned int last_time = 0;
    now_time = SDL_GetTicks();

    left_time = last_time + INTERVAL - now_time;

    if (last_time + INTERVAL > now_time) {
        SDL_Delay(left_time);
        last_time = now_time + left_time;
    } else last_time = now_time;
    return;
}

void fps_no(void) {
    static int tick = 0;
    static int fps_cnt = 0;
    fps_cnt++;
    if (tick + 1000 < SDL_GetTicks()) {
        printf("%dFPS\n", fps_cnt);
        fps_cnt = 0;
        tick = SDL_GetTicks();
    }
    return;
}
